//---------------------------------
// 2019/1/17

#include <Arduino.h>

#ifndef DS3231M_H
#define DS3231M_H

class DS3231M{
public:
  // String format
  static const uint8_t formatStringDay = 0;
  static const uint8_t formatStringMin = 1;
  static const uint8_t formatStringSec = 2;
  static const uint8_t formatFileDay = 3;
  static const uint8_t formatFileMin = 4;
  static const uint8_t formatFileSec = 5;

  // Alarm setting
  static const uint8_t alarmNone = 0;
  static const uint8_t alarmEveryTime = 1;
  static const uint8_t alarmSec = 2;
  static const uint8_t alarmMin = 3;
  static const uint8_t alarmHour = 4;
  static const uint8_t alarmDate = 5;

  struct RTCTime{
    uint8_t sec;
    uint8_t min;
    uint8_t hour;
    uint8_t date;
    uint8_t month;
    uint16_t year;
    
    uint8_t alarm;
  };
  // Device I2C Address
  static const uint8_t addrI2C = 0x68;

  DS3231M();
  bool begin();

  uint8_t read(uint8_t addr);
  void read(uint8_t addr, uint8_t*data, uint8_t length);
  void write(uint8_t addr, uint8_t data);
  void write(uint8_t addr, uint8_t*data, uint8_t length);

  void readTime(struct RTCTime*rtcTime);
  void writeTime(struct RTCTime*rtcTime);
  String readTimeStr(uint8_t format);
  String readTimeStr();
  float readTemp();

  void alarm(uint8_t alarmNum, struct RTCTime*rtcTime);
  void clearAlarm(uint8_t alarmNum);
  uint8_t checkAlarm();
};

#endif
